
/* A Bison parser, made by GNU Bison 2.4.1.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C
   
      Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.4.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Copy the first part of user declarations.  */

/* Line 189 of yacc.c  */
#line 22 "grammar.y"

#include "dstruct.h"
#include "syntax.h"
#include "lexicon.h"
#include "pragmatics.h"
#include "systemlog.h"
#include "stomp.h"
#include "show.h"

/* strings for error reporting */
char precede[]	 = "precede";
char follow[]	 = "follow";
char act_str[]	 = "action";
char bexp_str[]	 = "logical expression";
char aexp_str[]	 = "arithmetic expression";
char pexp_str[]	 = "arithmetic or string expression";
char quant_str[] = "quantifier";
char aggr_str[]  = "aggregation operator";
char pcnt_str[]  = "percentage quantifier";
char host_str[]  = "host name";
char inst_str[]  = "instance name";
char sample_str[]  = "sample number(s)";
char tstr_str[]	 = "(time interval optional) and string";
char num_str[]	 = "number";

/* report grammatical error */
static void
gramerr(char *phrase, char *pos, char *op)
{
    fprintf(stderr, "%s expected to %s %s\n", phrase, pos, op);
    lexSync();
}




/* Line 189 of yacc.c  */
#line 110 "grammar.tab.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     ARROW = 258,
     SHELL = 259,
     ALARM = 260,
     SYSLOG = 261,
     PRINT = 262,
     STOMP = 263,
     SOME_QUANT = 264,
     ALL_QUANT = 265,
     PCNT_QUANT = 266,
     LEQ_REL = 267,
     GEQ_REL = 268,
     NEQ_REL = 269,
     EQ_REL = 270,
     AND = 271,
     SEQ = 272,
     OR = 273,
     ALT = 274,
     NOT = 275,
     RISE = 276,
     FALL = 277,
     MATCH = 278,
     NOMATCH = 279,
     RULESET = 280,
     ELSE = 281,
     UNKNOWN = 282,
     OTHERWISE = 283,
     MIN_AGGR = 284,
     MAX_AGGR = 285,
     AVG_AGGR = 286,
     SUM_AGGR = 287,
     COUNT_AGGR = 288,
     TIME_DOM = 289,
     INST_DOM = 290,
     HOST_DOM = 291,
     UNIT_SLASH = 292,
     INTERVAL = 293,
     EVENT_UNIT = 294,
     TIME_UNIT = 295,
     SPACE_UNIT = 296,
     NUMBER = 297,
     IDENT = 298,
     STRING = 299,
     TRU = 300,
     FALS = 301,
     VAR = 302,
     INSTANT = 303,
     RATE = 304,
     UMINUS = 305
   };
#endif



#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */


/* Line 264 of yacc.c  */
#line 201 "grammar.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  122
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1570

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  64
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  26
/* YYNRULES -- Number of rules.  */
#define YYNRULES  155
/* YYNRULES -- Number of states.  */
#define YYNSTATES  245

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   305

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,    58,     2,     2,     2,     2,
      61,    62,    52,    50,     2,    51,     2,    53,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    57,     2,
      49,    60,    48,     2,    59,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,    63,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    54,    55,    56
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     4,     8,    10,    12,    14,    16,    18,
      20,    22,    26,    30,    33,    37,    41,    43,    47,    51,
      55,    62,    63,    67,    71,    75,    78,    82,    85,    89,
      92,    96,    99,   103,   106,   110,   113,   117,   120,   124,
     127,   130,   133,   136,   139,   141,   143,   146,   150,   152,
     154,   156,   158,   161,   164,   167,   171,   175,   179,   183,
     186,   189,   192,   195,   199,   202,   206,   209,   213,   216,
     220,   224,   228,   233,   237,   241,   246,   249,   253,   257,
     261,   265,   269,   273,   276,   280,   283,   287,   290,   294,
     297,   301,   304,   308,   311,   315,   319,   321,   323,   325,
     327,   330,   333,   336,   340,   344,   348,   352,   355,   358,
     361,   364,   368,   371,   375,   378,   382,   385,   389,   391,
     393,   397,   401,   405,   409,   413,   417,   421,   425,   429,
     433,   435,   437,   439,   444,   446,   447,   451,   455,   456,
     460,   464,   465,   468,   473,   476,   479,   480,   483,   487,
     489,   493,   495,   499,   501,   505
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int8 yyrhs[] =
{
      65,     0,    -1,    -1,    43,    60,    66,    -1,    66,    -1,
      67,    -1,    68,    -1,    74,    -1,    77,    -1,    71,    -1,
      89,    -1,    61,    67,    62,    -1,    74,     3,    71,    -1,
       1,     3,    -1,    74,     3,     1,    -1,    25,    69,    70,
      -1,    67,    -1,    67,    26,    69,    -1,    27,     3,    71,
      -1,    28,     3,    71,    -1,    27,     3,    71,    28,     3,
      71,    -1,    -1,    61,    71,    62,    -1,    71,    17,    71,
      -1,    71,    19,    71,    -1,     4,    72,    -1,     4,    86,
      72,    -1,     5,    72,    -1,     5,    86,    72,    -1,     6,
      72,    -1,     6,    86,    72,    -1,     7,    72,    -1,     7,
      86,    72,    -1,     8,    72,    -1,     8,    86,    72,    -1,
       1,    17,    -1,    71,    17,     1,    -1,     1,    19,    -1,
      71,    19,     1,    -1,     4,     1,    -1,     5,     1,    -1,
       6,     1,    -1,     7,     1,    -1,     8,     1,    -1,    73,
      -1,    44,    -1,    44,    73,    -1,    61,    74,    62,    -1,
      76,    -1,    75,    -1,    45,    -1,    46,    -1,    20,    74,
      -1,    21,    74,    -1,    22,    74,    -1,    74,    16,    74,
      -1,    74,    18,    74,    -1,    23,    89,    74,    -1,    24,
      89,    74,    -1,    20,     1,    -1,    21,     1,    -1,    22,
       1,    -1,    23,     1,    -1,    23,    89,     1,    -1,    24,
       1,    -1,    24,    89,     1,    -1,     1,    16,    -1,    74,
      16,     1,    -1,     1,    18,    -1,    74,    18,     1,    -1,
      10,    80,    74,    -1,     9,    80,    74,    -1,    42,    11,
      80,    74,    -1,    10,    80,     1,    -1,     9,    80,     1,
      -1,    42,    11,    80,     1,    -1,     1,    11,    -1,    78,
      15,    78,    -1,    78,    14,    78,    -1,    77,    49,    77,
      -1,    77,    48,    77,    -1,    77,    12,    77,    -1,    77,
      13,    77,    -1,     1,    15,    -1,    78,    15,     1,    -1,
       1,    14,    -1,    78,    14,     1,    -1,     1,    49,    -1,
      77,    49,     1,    -1,     1,    48,    -1,    77,    48,     1,
      -1,     1,    12,    -1,    77,    12,     1,    -1,     1,    13,
      -1,    77,    13,     1,    -1,    61,    77,    62,    -1,    81,
      -1,    86,    -1,    47,    -1,    79,    -1,    55,    77,    -1,
      54,    77,    -1,    51,    77,    -1,    77,    50,    77,    -1,
      77,    51,    77,    -1,    77,    52,    77,    -1,    77,    53,
      77,    -1,    55,     1,    -1,    54,     1,    -1,    51,     1,
      -1,     1,    50,    -1,    77,    50,     1,    -1,     1,    51,
      -1,    77,    51,     1,    -1,     1,    52,    -1,    77,    52,
       1,    -1,     1,    53,    -1,    77,    53,     1,    -1,    77,
      -1,    89,    -1,    32,    80,    77,    -1,    31,    80,    77,
      -1,    30,    80,    77,    -1,    29,    80,    77,    -1,    33,
      80,    74,    -1,    32,    80,     1,    -1,    31,    80,     1,
      -1,    30,    80,     1,    -1,    29,    80,     1,    -1,    33,
      80,     1,    -1,    36,    -1,    35,    -1,    34,    -1,    82,
      83,    84,    85,    -1,    43,    -1,    -1,    83,    57,    43,
      -1,    83,    57,     1,    -1,    -1,    84,    58,    43,    -1,
      84,    58,     1,    -1,    -1,    59,    42,    -1,    59,    42,
      38,    42,    -1,    59,     1,    -1,    42,    87,    -1,    -1,
      87,    88,    -1,    87,    37,    88,    -1,    41,    -1,    41,
      63,    42,    -1,    40,    -1,    40,    63,    42,    -1,    39,
      -1,    39,    63,    42,    -1,    44,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   157,   157,   158,   172,   183,   185,   187,   189,   191,
     193,   197,   199,   203,   206,   211,   215,   217,   226,   228,
     230,   233,   236,   238,   240,   242,   244,   246,   248,   250,
     254,   259,   261,   263,   268,   275,   279,   282,   285,   289,
     292,   295,   298,   301,   306,   310,   312,   316,   318,   320,
     322,   324,   326,   328,   330,   332,   334,   336,   342,   346,
     349,   352,   355,   358,   361,   364,   368,   371,   374,   377,
     383,   385,   387,   391,   394,   397,   400,   405,   417,   429,
     441,   453,   465,   479,   482,   485,   488,   491,   494,   497,
     500,   503,   506,   509,   512,   517,   519,   521,   523,   525,
     527,   533,   541,   547,   558,   569,   580,   593,   596,   599,
     603,   606,   609,   612,   615,   618,   621,   624,   630,   632,
     636,   638,   640,   642,   644,   648,   651,   654,   657,   660,
     665,   667,   669,   673,   677,   682,   684,   690,   697,   699,
     705,   712,   714,   717,   728,   734,   739,   740,   754,   770,
     772,   775,   777,   780,   782,   787
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "ARROW", "SHELL", "ALARM", "SYSLOG",
  "PRINT", "STOMP", "SOME_QUANT", "ALL_QUANT", "PCNT_QUANT", "LEQ_REL",
  "GEQ_REL", "NEQ_REL", "EQ_REL", "AND", "SEQ", "OR", "ALT", "NOT", "RISE",
  "FALL", "MATCH", "NOMATCH", "RULESET", "ELSE", "UNKNOWN", "OTHERWISE",
  "MIN_AGGR", "MAX_AGGR", "AVG_AGGR", "SUM_AGGR", "COUNT_AGGR", "TIME_DOM",
  "INST_DOM", "HOST_DOM", "UNIT_SLASH", "INTERVAL", "EVENT_UNIT",
  "TIME_UNIT", "SPACE_UNIT", "NUMBER", "IDENT", "STRING", "TRU", "FALS",
  "VAR", "'>'", "'<'", "'+'", "'-'", "'*'", "'/'", "INSTANT", "RATE",
  "UMINUS", "':'", "'#'", "'@'", "'='", "'('", "')'", "'^'", "$accept",
  "stmnt", "exp", "rule", "ruleset", "rulelist", "rulesetopt", "act",
  "actarg", "arglist", "bexp", "quant", "rexp", "aexp", "pexp", "aggr",
  "dom", "fetch", "metric", "hosts", "insts", "times", "num", "units",
  "unit", "str", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,    62,    60,
      43,    45,    42,    47,   303,   304,   305,    58,    35,    64,
      61,    40,    41,    94
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    64,    65,    65,    65,    66,    66,    66,    66,    66,
      66,    67,    67,    67,    67,    68,    69,    69,    70,    70,
      70,    70,    71,    71,    71,    71,    71,    71,    71,    71,
      71,    71,    71,    71,    71,    71,    71,    71,    71,    71,
      71,    71,    71,    71,    72,    73,    73,    74,    74,    74,
      74,    74,    74,    74,    74,    74,    74,    74,    74,    74,
      74,    74,    74,    74,    74,    74,    74,    74,    74,    74,
      75,    75,    75,    75,    75,    75,    75,    76,    76,    76,
      76,    76,    76,    76,    76,    76,    76,    76,    76,    76,
      76,    76,    76,    76,    76,    77,    77,    77,    77,    77,
      77,    77,    77,    77,    77,    77,    77,    77,    77,    77,
      77,    77,    77,    77,    77,    77,    77,    77,    78,    78,
      79,    79,    79,    79,    79,    79,    79,    79,    79,    79,
      80,    80,    80,    81,    82,    83,    83,    83,    84,    84,
      84,    85,    85,    85,    85,    86,    87,    87,    87,    88,
      88,    88,    88,    88,    88,    89
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     0,     3,     1,     1,     1,     1,     1,     1,
       1,     3,     3,     2,     3,     3,     1,     3,     3,     3,
       6,     0,     3,     3,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     2,     3,     2,
       2,     2,     2,     2,     1,     1,     2,     3,     1,     1,
       1,     1,     2,     2,     2,     3,     3,     3,     3,     2,
       2,     2,     2,     3,     2,     3,     2,     3,     2,     3,
       3,     3,     4,     3,     3,     4,     2,     3,     3,     3,
       3,     3,     3,     2,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     3,     1,     1,     1,     1,
       2,     2,     2,     3,     3,     3,     3,     2,     2,     2,
       2,     3,     2,     3,     2,     3,     2,     3,     1,     1,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       1,     1,     1,     4,     1,     0,     3,     3,     0,     3,
       3,     0,     2,     4,     2,     2,     0,     2,     3,     1,
       3,     1,     3,     1,     3,     1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     146,   134,   155,    50,    51,    98,     0,     0,     0,     0,
       0,     4,     5,     6,     9,     7,    49,    48,   118,     0,
      99,    96,   135,    97,   119,    13,    76,    91,    93,    85,
      83,    66,    35,    68,    37,    89,    87,   110,   112,   114,
     116,    39,   146,    45,    25,    44,     0,    40,    27,     0,
      41,    29,     0,    42,    31,     0,    43,    33,     0,   132,
     131,   130,     0,     0,    59,   134,     0,    52,   118,   119,
      60,    53,    61,    54,    62,     0,    64,     0,     0,     0,
      16,    21,     0,     0,     0,     0,     0,     0,     0,   145,
       0,   109,     0,   102,   108,   101,   107,   100,     0,     0,
       0,   118,     1,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   138,    46,
      26,    28,    30,    32,    34,    74,    71,    73,    70,     0,
       0,    63,    57,    65,    58,     0,     0,     0,    15,   128,
     123,   127,   122,   126,   121,   125,   120,   129,   124,     0,
       0,   153,   151,   149,   147,     3,     0,     0,    11,    22,
      47,    95,    36,     0,    23,    38,    24,    14,    12,    67,
      55,    69,    56,    92,    81,    94,    82,    90,    80,    88,
      79,   111,   103,   113,   104,   115,   105,   117,   106,    86,
     118,    78,    84,    77,     0,   141,    17,     0,     0,    75,
      72,   148,     0,     0,     0,     0,   137,   136,     0,     0,
     133,    18,    19,   154,   152,   150,   140,   139,   144,   142,
       0,     0,     0,   143,    20
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    30,    31,    32,    33,   101,   158,    34,    64,    65,
      35,    36,    37,    88,    39,    40,    82,    41,    42,   138,
     215,   230,    43,   109,   174,    89
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -41
static const yytype_int16 yypact[] =
{
     176,  1517,    17,    18,    27,    42,    69,   117,   117,   339,
     386,   433,    41,    48,   480,   117,   117,   117,   117,   117,
      -3,   -28,   -41,   -41,   -41,   -41,   991,  1025,  1052,   292,
      58,   -41,   -41,   -41,   106,   104,   -41,   -41,  1474,    25,
     -41,   -41,   -41,   -41,    68,   -41,   -41,   -41,   -41,   -41,
     -41,   -41,   -41,   -41,   -41,   -41,   -41,   -41,   -41,   -41,
     -41,   -41,   -41,    44,   -41,   -41,    44,   -41,   -41,    44,
     -41,   -41,    44,   -41,   -41,    44,   -41,   -41,    44,   -41,
     -41,   -41,   527,   574,  1503,   -41,   621,   -41,   278,   -41,
    1503,   -41,  1503,   -41,   -41,   668,   -41,   715,   257,   480,
      72,    89,   104,  1086,  1113,  1147,  1174,   762,   117,   123,
     234,   -41,  1208,   -41,   -40,   -41,   -40,   -41,    43,   -10,
      11,   199,   -41,    40,    49,    75,   809,   856,  1235,  1269,
    1296,  1330,  1357,  1391,  1418,  1452,   930,   964,    45,   -41,
     -41,   -41,   -41,   -41,   -41,  1503,   -41,  1503,   -41,  1503,
      15,  1503,   -41,  1503,   -41,   480,   105,   118,   -41,   -40,
     -41,   -40,   -41,   -40,   -41,   -40,   -41,  1503,   -41,   903,
     185,    66,    76,    82,   -41,   -41,   -40,   140,   -41,   -41,
     -41,   -41,   109,   126,   -41,   109,   -41,   109,   106,  1503,
     -41,  1503,   -41,   -40,   164,   -40,   164,   -40,   164,   -40,
     164,   -40,   142,   -40,   142,   -40,   -41,   -40,   -41,   -40,
     164,   -41,   -40,   -41,    29,   120,   -41,   126,   126,  1503,
     -41,   -41,    70,    93,   168,   109,   -41,   -41,    50,    62,
     -41,   121,   106,   -41,   -41,   -41,   -41,   -41,   -41,   127,
     225,   187,   126,   -41,   106
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
     -41,   -41,   122,    -9,   -41,    78,   -41,   -29,    31,   171,
      -8,   -41,   -41,    38,    67,   -41,     7,   -41,   -41,   -41,
     -41,   -41,   153,   -41,    83,     4
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -11
static const yytype_int16 yytable[] =
{
     119,    87,    91,    93,    44,   100,   102,   123,   108,   124,
      57,    58,    59,    60,   125,    83,    95,    97,    61,    67,
     118,   120,   103,   104,   105,   106,   107,   126,    70,   127,
     226,   126,   110,   127,    68,    71,    74,    77,    38,   136,
     137,   182,    94,    73,     2,     3,     4,     5,     6,    96,
     185,   236,   179,     2,     3,     4,     5,     6,   122,    62,
      62,    63,    63,   238,   113,   115,   117,   121,   -10,    62,
      76,    63,   227,   180,   146,   148,   187,   180,   150,     2,
       3,     4,     5,     6,    62,    22,    63,   152,    63,   154,
     118,   120,    22,   237,   184,   186,   188,   140,   155,   168,
     141,   183,   214,   142,   239,   178,   143,   125,   217,   144,
     183,    62,   233,    63,    44,   169,   156,   157,   190,   192,
     126,   218,   127,   123,   121,   124,    52,   225,    54,   222,
       2,     3,     4,     5,     6,   234,   183,   121,   123,   223,
     124,   160,   162,   164,   166,   224,   100,   102,    38,   240,
     177,    79,    80,    81,   119,    66,    69,    72,    75,    78,
     170,   220,   171,   172,   173,   241,   194,   196,   198,   200,
     202,   204,   206,   208,   210,   210,    -2,     1,   228,   229,
       2,     3,     4,     5,     6,     7,     8,   183,   231,   232,
     132,   133,   134,   135,   134,   135,     9,    10,    11,    12,
      13,    14,   181,   211,   213,    15,    16,    17,    18,    19,
     235,   128,   129,   244,   132,   133,   134,   135,    20,    21,
      22,    23,    24,    25,   171,   172,   173,    26,   242,   243,
      27,    28,   175,   216,   139,     1,     0,    29,     2,     3,
       4,     5,     6,     7,     8,     0,     0,   130,   131,   132,
     133,   134,   135,   221,     9,    10,    11,    12,    13,    14,
      45,   181,     0,    15,    16,    17,    18,    19,    46,    47,
      48,    49,    50,    51,     0,    53,    20,    85,    22,    23,
      24,    25,     0,     0,     0,    26,     0,     0,    27,    28,
     128,   129,     0,     1,     0,    29,     2,     3,     4,     5,
       6,     7,     8,     0,     0,    55,    56,    57,    58,    59,
      60,     0,     9,    10,    11,    12,    13,     0,     0,     0,
       0,    15,    16,    17,    18,    19,   130,   131,   132,   133,
     134,   135,     0,     0,    20,    85,    22,    23,    24,    25,
      84,     0,     0,    26,     0,     0,    27,    28,     7,     8,
       0,     0,     0,    29,     0,     0,     0,     0,     0,     9,
      10,    11,    12,    13,     0,     0,     0,     0,    15,    16,
      17,    18,    19,     0,     0,     0,     0,     0,     0,     0,
       0,    20,    85,    22,    23,    24,    25,    90,     0,     0,
      26,     0,     0,    27,    28,     7,     8,     0,     0,     0,
      86,     0,     0,     0,     0,     0,     9,    10,    11,    12,
      13,     0,     0,     0,     0,    15,    16,    17,    18,    19,
       0,     0,     0,     0,     0,     0,     0,     0,    20,    85,
      22,    23,    24,    25,    92,     0,     0,    26,     0,     0,
      27,    28,     7,     8,     0,     0,     0,    86,     0,     0,
       0,     0,     0,     9,    10,    11,    12,    13,     0,     0,
       0,     0,    15,    16,    17,    18,    19,     0,     0,     0,
       0,     0,     0,     0,     0,    20,    85,    22,    23,    24,
      25,    98,     0,     0,    26,     0,     0,    27,    28,     7,
       8,     0,     0,     0,    86,     0,     0,     0,     0,     0,
       9,    10,    11,    12,    13,     0,     0,     0,     0,    15,
      16,    17,    18,    19,     0,     0,     0,     0,     0,     0,
       0,     0,    20,    85,    22,    23,    24,    25,   145,     0,
       0,    26,     0,     0,    27,    28,     7,     8,     0,     0,
       0,    99,     0,     0,     0,     0,     0,     9,    10,    11,
      12,    13,     0,     0,     0,     0,    15,    16,    17,    18,
      19,     0,     0,     0,     0,     0,     0,     0,     0,    20,
      85,    22,    23,    24,    25,   147,     0,     0,    26,     0,
       0,    27,    28,     7,     8,     0,     0,     0,    86,     0,
       0,     0,     0,     0,     9,    10,    11,    12,    13,     0,
       0,     0,     0,    15,    16,    17,    18,    19,     0,     0,
       0,     0,     0,     0,     0,     0,    20,    85,    22,    23,
      24,    25,   149,     0,     0,    26,     0,     0,    27,    28,
       7,     8,     0,     0,     0,    86,     0,     0,     0,     0,
       0,     9,    10,    11,    12,    13,     0,     0,     0,     0,
      15,    16,    17,    18,    19,     0,     0,     0,     0,     0,
       0,     0,     0,    20,    85,    22,    23,    24,    25,   151,
       0,     0,    26,     0,     0,    27,    28,     7,     8,     0,
       0,     0,    86,     0,     0,     0,     0,     0,     9,    10,
      11,    12,    13,     0,     0,     0,     0,    15,    16,    17,
      18,    19,     0,     0,     0,     0,     0,     0,     0,     0,
      20,    85,    22,    23,    24,    25,   153,     0,     0,    26,
       0,     0,    27,    28,     7,     8,     0,     0,     0,    86,
       0,     0,     0,     0,     0,     9,    10,    11,    12,    13,
       0,     0,     0,     0,    15,    16,    17,    18,    19,     0,
       0,     0,     0,     0,     0,     0,     0,    20,    85,    22,
      23,    24,    25,   167,     0,     0,    26,     0,     0,    27,
      28,     7,     8,     0,     0,     0,    86,     0,     0,     0,
       0,     0,     9,    10,    11,    12,    13,     0,     0,     0,
       0,    15,    16,    17,    18,    19,     0,     0,     0,     0,
       0,     0,     0,     0,    20,    85,    22,    23,    24,    25,
     189,     0,     0,    26,     0,     0,    27,    28,     7,     8,
       0,     0,     0,    86,     0,     0,     0,     0,     0,     9,
      10,    11,    12,    13,     0,     0,     0,     0,    15,    16,
      17,    18,    19,     0,     0,     0,     0,     0,     0,     0,
       0,    20,    85,    22,    23,    24,    25,   191,     0,     0,
      26,     0,     0,    27,    28,     7,     8,     0,     0,     0,
      86,     0,     0,     0,     0,     0,     9,    10,    11,    12,
      13,     0,     0,     0,     0,    15,    16,    17,    18,    19,
       0,     0,     0,     0,     0,     0,     0,     0,    20,    85,
      22,    23,    24,    25,   219,     0,     0,    26,     0,     0,
      27,    28,     7,     8,     0,     0,     0,    86,     0,     0,
       0,     0,     0,     9,    10,    11,    12,    13,     0,     0,
       0,   209,    15,    16,    17,    18,    19,     0,     0,     0,
       0,     0,     0,     0,     0,    20,    85,    22,    23,    24,
      25,     0,     0,     0,    26,     0,     0,    27,    28,    15,
      16,    17,    18,    19,    86,   212,     0,     0,     0,     0,
       0,     0,    62,    85,    22,     0,     0,    25,     0,     0,
       0,    26,     0,     0,    27,    28,     0,     0,     0,     0,
       0,   112,   111,    15,    16,    17,    18,    19,     0,     0,
       0,     0,     0,     0,     0,     0,    62,    85,    22,     0,
       0,    25,     0,     0,     0,    26,     0,     0,    27,    28,
      15,    16,    17,    18,    19,   112,   114,     0,     0,     0,
       0,     0,     0,    62,    85,     0,     0,     0,    25,     0,
       0,     0,    26,     0,     0,    27,    28,     0,     0,     0,
       0,     0,   112,   116,    15,    16,    17,    18,    19,     0,
       0,     0,     0,     0,     0,     0,     0,    62,    85,     0,
       0,     0,    25,     0,     0,     0,    26,     0,     0,    27,
      28,    15,    16,    17,    18,    19,   112,   159,     0,     0,
       0,     0,     0,     0,    62,    85,     0,     0,     0,    25,
       0,     0,     0,    26,     0,     0,    27,    28,     0,     0,
       0,     0,     0,   112,   161,    15,    16,    17,    18,    19,
       0,     0,     0,     0,     0,     0,     0,     0,    62,    85,
       0,     0,     0,    25,     0,     0,     0,    26,     0,     0,
      27,    28,    15,    16,    17,    18,    19,   112,   163,     0,
       0,     0,     0,     0,     0,    62,    85,     0,     0,     0,
      25,     0,     0,     0,    26,     0,     0,    27,    28,     0,
       0,     0,     0,     0,   112,   165,    15,    16,    17,    18,
      19,     0,     0,     0,     0,     0,     0,     0,     0,    62,
      85,     0,     0,     0,    25,     0,     0,     0,    26,     0,
       0,    27,    28,    15,    16,    17,    18,    19,   112,   176,
       0,     0,     0,     0,     0,     0,    62,    85,     0,     0,
       0,    25,     0,     0,     0,    26,     0,     0,    27,    28,
       0,     0,     0,     0,     0,   112,   193,    15,    16,    17,
      18,    19,     0,     0,     0,     0,     0,     0,     0,     0,
      62,    85,     0,     0,     0,    25,     0,     0,     0,    26,
       0,     0,    27,    28,    15,    16,    17,    18,    19,   112,
     195,     0,     0,     0,     0,     0,     0,    62,    85,     0,
       0,     0,    25,     0,     0,     0,    26,     0,     0,    27,
      28,     0,     0,     0,     0,     0,   112,   197,    15,    16,
      17,    18,    19,     0,     0,     0,     0,     0,     0,     0,
       0,    62,    85,     0,     0,     0,    25,     0,     0,     0,
      26,     0,     0,    27,    28,    15,    16,    17,    18,    19,
     112,   199,     0,     0,     0,     0,     0,     0,    62,    85,
       0,     0,     0,    25,     0,     0,     0,    26,     0,     0,
      27,    28,     0,     0,     0,     0,     0,   112,   201,    15,
      16,    17,    18,    19,     0,     0,     0,     0,     0,     0,
       0,     0,    62,    85,     0,     0,     0,    25,     0,     0,
       0,    26,     0,     0,    27,    28,    15,    16,    17,    18,
      19,   112,   203,     0,     0,     0,     0,     0,     0,    62,
      85,     0,     0,     0,    25,     0,     0,     0,    26,     0,
       0,    27,    28,     0,     0,     0,     0,     0,   112,   205,
      15,    16,    17,    18,    19,     0,     0,     0,     0,     0,
       0,     0,     0,    62,    85,     0,     0,     0,    25,     0,
       0,     0,    26,     0,     0,    27,    28,    15,    16,    17,
      18,    19,   112,   207,     0,     0,     0,     0,     0,     0,
      62,    85,     0,     0,     0,    25,     0,     0,     0,    26,
       0,     0,    27,    28,    -8,     0,     0,     0,     0,   112,
       0,    15,    16,    17,    18,    19,   128,   129,     0,     0,
       0,     0,     0,     0,    62,    85,     0,     0,     0,    25,
       0,     0,     0,    26,     0,     0,    27,    28,     0,     0,
       0,     0,     0,   112,    46,    47,    48,    49,    50,    51,
      45,    53,   130,   131,   132,   133,   134,   135,    46,    47,
      48,    49,    50,    51,    52,    53,    54,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    55,    56,    57,    58,    59,    60,     0,     0,     0,
       0,     0,     0,     0,     0,    55,    56,    57,    58,    59,
      60
};

static const yytype_int16 yycheck[] =
{
      29,     9,    10,    11,     0,    14,    14,    17,    11,    19,
      50,    51,    52,    53,     3,     8,    12,    13,     1,     1,
      29,    29,    15,    16,    17,    18,    19,    16,     1,    18,
       1,    16,    60,    18,     3,     4,     5,     6,     0,    14,
      15,     1,     1,     1,     4,     5,     6,     7,     8,     1,
       1,     1,    62,     4,     5,     6,     7,     8,     0,    42,
      42,    44,    44,     1,    26,    27,    28,    29,     0,    42,
       1,    44,    43,    62,    82,    83,     1,    62,    86,     4,
       5,     6,     7,     8,    42,    44,    44,    95,    44,    97,
      99,    99,    44,    43,   123,   124,   125,    66,    26,   107,
      69,    61,    57,    72,    42,    62,    75,     3,     3,    78,
      61,    42,    42,    44,   110,   108,    27,    28,   126,   127,
      16,     3,    18,    17,    86,    19,    17,     1,    19,    63,
       4,     5,     6,     7,     8,    42,    61,    99,    17,    63,
      19,   103,   104,   105,   106,    63,   155,   155,   110,    28,
     112,    34,    35,    36,   183,     2,     3,     4,     5,     6,
      37,   169,    39,    40,    41,    38,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,     0,     1,    58,    59,
       4,     5,     6,     7,     8,     9,    10,    61,   217,   218,
      50,    51,    52,    53,    52,    53,    20,    21,    22,    23,
      24,    25,    62,   136,   137,    29,    30,    31,    32,    33,
      42,    12,    13,   242,    50,    51,    52,    53,    42,    43,
      44,    45,    46,    47,    39,    40,    41,    51,     3,    42,
      54,    55,   110,   155,    63,     1,    -1,    61,     4,     5,
       6,     7,     8,     9,    10,    -1,    -1,    48,    49,    50,
      51,    52,    53,   170,    20,    21,    22,    23,    24,    25,
       3,    62,    -1,    29,    30,    31,    32,    33,    11,    12,
      13,    14,    15,    16,    -1,    18,    42,    43,    44,    45,
      46,    47,    -1,    -1,    -1,    51,    -1,    -1,    54,    55,
      12,    13,    -1,     1,    -1,    61,     4,     5,     6,     7,
       8,     9,    10,    -1,    -1,    48,    49,    50,    51,    52,
      53,    -1,    20,    21,    22,    23,    24,    -1,    -1,    -1,
      -1,    29,    30,    31,    32,    33,    48,    49,    50,    51,
      52,    53,    -1,    -1,    42,    43,    44,    45,    46,    47,
       1,    -1,    -1,    51,    -1,    -1,    54,    55,     9,    10,
      -1,    -1,    -1,    61,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    -1,    -1,    -1,    -1,    29,    30,
      31,    32,    33,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    42,    43,    44,    45,    46,    47,     1,    -1,    -1,
      51,    -1,    -1,    54,    55,     9,    10,    -1,    -1,    -1,
      61,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    -1,    -1,    -1,    -1,    29,    30,    31,    32,    33,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    42,    43,
      44,    45,    46,    47,     1,    -1,    -1,    51,    -1,    -1,
      54,    55,     9,    10,    -1,    -1,    -1,    61,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    -1,    -1,
      -1,    -1,    29,    30,    31,    32,    33,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    42,    43,    44,    45,    46,
      47,     1,    -1,    -1,    51,    -1,    -1,    54,    55,     9,
      10,    -1,    -1,    -1,    61,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    -1,    -1,    -1,    -1,    29,
      30,    31,    32,    33,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    42,    43,    44,    45,    46,    47,     1,    -1,
      -1,    51,    -1,    -1,    54,    55,     9,    10,    -1,    -1,
      -1,    61,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    -1,    -1,    -1,    -1,    29,    30,    31,    32,
      33,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    42,
      43,    44,    45,    46,    47,     1,    -1,    -1,    51,    -1,
      -1,    54,    55,     9,    10,    -1,    -1,    -1,    61,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    -1,
      -1,    -1,    -1,    29,    30,    31,    32,    33,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    42,    43,    44,    45,
      46,    47,     1,    -1,    -1,    51,    -1,    -1,    54,    55,
       9,    10,    -1,    -1,    -1,    61,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    -1,    -1,    -1,    -1,
      29,    30,    31,    32,    33,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    42,    43,    44,    45,    46,    47,     1,
      -1,    -1,    51,    -1,    -1,    54,    55,     9,    10,    -1,
      -1,    -1,    61,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    -1,    -1,    -1,    -1,    29,    30,    31,
      32,    33,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      42,    43,    44,    45,    46,    47,     1,    -1,    -1,    51,
      -1,    -1,    54,    55,     9,    10,    -1,    -1,    -1,    61,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      -1,    -1,    -1,    -1,    29,    30,    31,    32,    33,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    42,    43,    44,
      45,    46,    47,     1,    -1,    -1,    51,    -1,    -1,    54,
      55,     9,    10,    -1,    -1,    -1,    61,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    -1,    -1,    -1,
      -1,    29,    30,    31,    32,    33,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    42,    43,    44,    45,    46,    47,
       1,    -1,    -1,    51,    -1,    -1,    54,    55,     9,    10,
      -1,    -1,    -1,    61,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    -1,    -1,    -1,    -1,    29,    30,
      31,    32,    33,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    42,    43,    44,    45,    46,    47,     1,    -1,    -1,
      51,    -1,    -1,    54,    55,     9,    10,    -1,    -1,    -1,
      61,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    -1,    -1,    -1,    -1,    29,    30,    31,    32,    33,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    42,    43,
      44,    45,    46,    47,     1,    -1,    -1,    51,    -1,    -1,
      54,    55,     9,    10,    -1,    -1,    -1,    61,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    -1,    -1,
      -1,     1,    29,    30,    31,    32,    33,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    42,    43,    44,    45,    46,
      47,    -1,    -1,    -1,    51,    -1,    -1,    54,    55,    29,
      30,    31,    32,    33,    61,     1,    -1,    -1,    -1,    -1,
      -1,    -1,    42,    43,    44,    -1,    -1,    47,    -1,    -1,
      -1,    51,    -1,    -1,    54,    55,    -1,    -1,    -1,    -1,
      -1,    61,     1,    29,    30,    31,    32,    33,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    42,    43,    44,    -1,
      -1,    47,    -1,    -1,    -1,    51,    -1,    -1,    54,    55,
      29,    30,    31,    32,    33,    61,     1,    -1,    -1,    -1,
      -1,    -1,    -1,    42,    43,    -1,    -1,    -1,    47,    -1,
      -1,    -1,    51,    -1,    -1,    54,    55,    -1,    -1,    -1,
      -1,    -1,    61,     1,    29,    30,    31,    32,    33,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    42,    43,    -1,
      -1,    -1,    47,    -1,    -1,    -1,    51,    -1,    -1,    54,
      55,    29,    30,    31,    32,    33,    61,     1,    -1,    -1,
      -1,    -1,    -1,    -1,    42,    43,    -1,    -1,    -1,    47,
      -1,    -1,    -1,    51,    -1,    -1,    54,    55,    -1,    -1,
      -1,    -1,    -1,    61,     1,    29,    30,    31,    32,    33,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    42,    43,
      -1,    -1,    -1,    47,    -1,    -1,    -1,    51,    -1,    -1,
      54,    55,    29,    30,    31,    32,    33,    61,     1,    -1,
      -1,    -1,    -1,    -1,    -1,    42,    43,    -1,    -1,    -1,
      47,    -1,    -1,    -1,    51,    -1,    -1,    54,    55,    -1,
      -1,    -1,    -1,    -1,    61,     1,    29,    30,    31,    32,
      33,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    42,
      43,    -1,    -1,    -1,    47,    -1,    -1,    -1,    51,    -1,
      -1,    54,    55,    29,    30,    31,    32,    33,    61,     1,
      -1,    -1,    -1,    -1,    -1,    -1,    42,    43,    -1,    -1,
      -1,    47,    -1,    -1,    -1,    51,    -1,    -1,    54,    55,
      -1,    -1,    -1,    -1,    -1,    61,     1,    29,    30,    31,
      32,    33,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      42,    43,    -1,    -1,    -1,    47,    -1,    -1,    -1,    51,
      -1,    -1,    54,    55,    29,    30,    31,    32,    33,    61,
       1,    -1,    -1,    -1,    -1,    -1,    -1,    42,    43,    -1,
      -1,    -1,    47,    -1,    -1,    -1,    51,    -1,    -1,    54,
      55,    -1,    -1,    -1,    -1,    -1,    61,     1,    29,    30,
      31,    32,    33,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    42,    43,    -1,    -1,    -1,    47,    -1,    -1,    -1,
      51,    -1,    -1,    54,    55,    29,    30,    31,    32,    33,
      61,     1,    -1,    -1,    -1,    -1,    -1,    -1,    42,    43,
      -1,    -1,    -1,    47,    -1,    -1,    -1,    51,    -1,    -1,
      54,    55,    -1,    -1,    -1,    -1,    -1,    61,     1,    29,
      30,    31,    32,    33,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    42,    43,    -1,    -1,    -1,    47,    -1,    -1,
      -1,    51,    -1,    -1,    54,    55,    29,    30,    31,    32,
      33,    61,     1,    -1,    -1,    -1,    -1,    -1,    -1,    42,
      43,    -1,    -1,    -1,    47,    -1,    -1,    -1,    51,    -1,
      -1,    54,    55,    -1,    -1,    -1,    -1,    -1,    61,     1,
      29,    30,    31,    32,    33,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    42,    43,    -1,    -1,    -1,    47,    -1,
      -1,    -1,    51,    -1,    -1,    54,    55,    29,    30,    31,
      32,    33,    61,     1,    -1,    -1,    -1,    -1,    -1,    -1,
      42,    43,    -1,    -1,    -1,    47,    -1,    -1,    -1,    51,
      -1,    -1,    54,    55,     0,    -1,    -1,    -1,    -1,    61,
      -1,    29,    30,    31,    32,    33,    12,    13,    -1,    -1,
      -1,    -1,    -1,    -1,    42,    43,    -1,    -1,    -1,    47,
      -1,    -1,    -1,    51,    -1,    -1,    54,    55,    -1,    -1,
      -1,    -1,    -1,    61,    11,    12,    13,    14,    15,    16,
       3,    18,    48,    49,    50,    51,    52,    53,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    48,    49,    50,    51,    52,    53,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    48,    49,    50,    51,    52,
      53
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     1,     4,     5,     6,     7,     8,     9,    10,    20,
      21,    22,    23,    24,    25,    29,    30,    31,    32,    33,
      42,    43,    44,    45,    46,    47,    51,    54,    55,    61,
      65,    66,    67,    68,    71,    74,    75,    76,    77,    78,
      79,    81,    82,    86,    89,     3,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    48,    49,    50,    51,    52,
      53,     1,    42,    44,    72,    73,    86,     1,    72,    86,
       1,    72,    86,     1,    72,    86,     1,    72,    86,    34,
      35,    36,    80,    80,     1,    43,    61,    74,    77,    89,
       1,    74,     1,    74,     1,    89,     1,    89,     1,    61,
      67,    69,    74,    80,    80,    80,    80,    80,    11,    87,
      60,     1,    61,    77,     1,    77,     1,    77,    67,    71,
      74,    77,     0,    17,    19,     3,    16,    18,    12,    13,
      48,    49,    50,    51,    52,    53,    14,    15,    83,    73,
      72,    72,    72,    72,    72,     1,    74,     1,    74,     1,
      74,     1,    74,     1,    74,    26,    27,    28,    70,     1,
      77,     1,    77,     1,    77,     1,    77,     1,    74,    80,
      37,    39,    40,    41,    88,    66,     1,    77,    62,    62,
      62,    62,     1,    61,    71,     1,    71,     1,    71,     1,
      74,     1,    74,     1,    77,     1,    77,     1,    77,     1,
      77,     1,    77,     1,    77,     1,    77,     1,    77,     1,
      77,    78,     1,    78,    57,    84,    69,     3,     3,     1,
      74,    88,    63,    63,    63,     1,     1,    43,    58,    59,
      85,    71,    71,    42,    42,    42,     1,    43,     1,    42,
      28,    38,     3,    42,    71
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}

/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*-------------------------.
| yyparse or yypush_parse.  |
`-------------------------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{


    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:

/* Line 1455 of yacc.c  */
#line 157 "grammar.y"
    {    parse = NULL; ;}
    break;

  case 3:

/* Line 1455 of yacc.c  */
#line 159 "grammar.y"
    {   parse = statement((yyvsp[(1) - (3)].s), (yyvsp[(3) - (3)].x));
		    if ((agent || applet) && (yyvsp[(3) - (3)].x) != NULL &&
			((yyvsp[(3) - (3)].x)->op == RULE || (yyvsp[(3) - (3)].x)->op == ACT_SEQ ||
			 (yyvsp[(3) - (3)].x)->op == ACT_ALT || (yyvsp[(3) - (3)].x)->op == ACT_SHELL ||
			 (yyvsp[(3) - (3)].x)->op == ACT_ALARM || (yyvsp[(3) - (3)].x)->op == ACT_SYSLOG ||
			 (yyvsp[(3) - (3)].x)->op == ACT_PRINT || (yyvsp[(3) - (3)].x)->op == ACT_STOMP)) {
			synerr();
			fprintf(stderr, "operator %s not allowed in agent "
					"mode\n", opStrings((yyvsp[(3) - (3)].x)->op));
			parse = NULL;
		    }
		    free((yyvsp[(1) - (3)].s));
		;}
    break;

  case 4:

/* Line 1455 of yacc.c  */
#line 173 "grammar.y"
    {   parse = statement(NULL, (yyvsp[(1) - (1)].x));
		    if (agent) {
			synerr();
			fprintf(stderr, "expressions must be named in agent "
					"mode\n");
			parse = NULL;
		    }
		;}
    break;

  case 5:

/* Line 1455 of yacc.c  */
#line 184 "grammar.y"
    {   (yyval.x) = (yyvsp[(1) - (1)].x); ;}
    break;

  case 6:

/* Line 1455 of yacc.c  */
#line 186 "grammar.y"
    {   (yyval.x) = (yyvsp[(1) - (1)].x); ;}
    break;

  case 7:

/* Line 1455 of yacc.c  */
#line 188 "grammar.y"
    {   (yyval.x) = (yyvsp[(1) - (1)].x); ;}
    break;

  case 8:

/* Line 1455 of yacc.c  */
#line 190 "grammar.y"
    {   (yyval.x) = (yyvsp[(1) - (1)].x); ;}
    break;

  case 9:

/* Line 1455 of yacc.c  */
#line 192 "grammar.y"
    {   (yyval.x) = (yyvsp[(1) - (1)].x); ;}
    break;

  case 10:

/* Line 1455 of yacc.c  */
#line 194 "grammar.y"
    {   (yyval.x) = (yyvsp[(1) - (1)].x); ;}
    break;

  case 11:

/* Line 1455 of yacc.c  */
#line 198 "grammar.y"
    {   (yyval.x) = (yyvsp[(2) - (3)].x); ;}
    break;

  case 12:

/* Line 1455 of yacc.c  */
#line 200 "grammar.y"
    {    (yyval.x) = ruleExpr((yyvsp[(1) - (3)].x), (yyvsp[(3) - (3)].x)); ;}
    break;

  case 13:

/* Line 1455 of yacc.c  */
#line 204 "grammar.y"
    {   gramerr(bexp_str, precede, opStrings(RULE));
		    (yyval.x) = NULL; ;}
    break;

  case 14:

/* Line 1455 of yacc.c  */
#line 207 "grammar.y"
    {   gramerr(act_str, follow, opStrings(RULE));
		    (yyval.x) = NULL; ;}
    break;

  case 15:

/* Line 1455 of yacc.c  */
#line 212 "grammar.y"
    {   (yyval.x) = binaryExpr(CND_RULESET, (yyvsp[(2) - (3)].x), (yyvsp[(3) - (3)].x)); ;}
    break;

  case 16:

/* Line 1455 of yacc.c  */
#line 216 "grammar.y"
    {   (yyval.x) = (yyvsp[(1) - (1)].x); ;}
    break;

  case 17:

/* Line 1455 of yacc.c  */
#line 223 "grammar.y"
    {   (yyval.x) = binaryExpr(CND_OR, (yyvsp[(1) - (3)].x), (yyvsp[(3) - (3)].x)); ;}
    break;

  case 18:

/* Line 1455 of yacc.c  */
#line 227 "grammar.y"
    {    (yyval.x) = binaryExpr(CND_OTHER, ruleExpr(boolConst(B_TRUE), (yyvsp[(3) - (3)].x)), boolConst(B_FALSE)); ;}
    break;

  case 19:

/* Line 1455 of yacc.c  */
#line 229 "grammar.y"
    {    (yyval.x) = binaryExpr(CND_OTHER, boolConst(B_FALSE), ruleExpr(boolConst(B_TRUE), (yyvsp[(3) - (3)].x))); ;}
    break;

  case 20:

/* Line 1455 of yacc.c  */
#line 231 "grammar.y"
    {    (yyval.x) = binaryExpr(CND_OTHER, ruleExpr(boolConst(B_TRUE), (yyvsp[(3) - (6)].x)), ruleExpr(boolConst(B_TRUE), (yyvsp[(6) - (6)].x))); ;}
    break;

  case 21:

/* Line 1455 of yacc.c  */
#line 233 "grammar.y"
    {    (yyval.x) = NULL; ;}
    break;

  case 22:

/* Line 1455 of yacc.c  */
#line 237 "grammar.y"
    {   (yyval.x) = (yyvsp[(2) - (3)].x); ;}
    break;

  case 23:

/* Line 1455 of yacc.c  */
#line 239 "grammar.y"
    {   (yyval.x) = actExpr(ACT_SEQ, (yyvsp[(1) - (3)].x), (yyvsp[(3) - (3)].x)); ;}
    break;

  case 24:

/* Line 1455 of yacc.c  */
#line 241 "grammar.y"
    {   (yyval.x) = actExpr(ACT_ALT, (yyvsp[(1) - (3)].x), (yyvsp[(3) - (3)].x)); ;}
    break;

  case 25:

/* Line 1455 of yacc.c  */
#line 243 "grammar.y"
    {   (yyval.x) = actExpr(ACT_SHELL, (yyvsp[(2) - (2)].x), NULL); ;}
    break;

  case 26:

/* Line 1455 of yacc.c  */
#line 245 "grammar.y"
    {   (yyval.x) = actExpr(ACT_SHELL, (yyvsp[(3) - (3)].x), (yyvsp[(2) - (3)].x)); ;}
    break;

  case 27:

/* Line 1455 of yacc.c  */
#line 247 "grammar.y"
    {   (yyval.x) = actExpr(ACT_ALARM, (yyvsp[(2) - (2)].x), NULL); ;}
    break;

  case 28:

/* Line 1455 of yacc.c  */
#line 249 "grammar.y"
    {   (yyval.x) = actExpr(ACT_ALARM, (yyvsp[(3) - (3)].x), (yyvsp[(2) - (3)].x)); ;}
    break;

  case 29:

/* Line 1455 of yacc.c  */
#line 251 "grammar.y"
    {   do_syslog_args((yyvsp[(2) - (2)].x));
		    (yyval.x) = actExpr(ACT_SYSLOG, (yyvsp[(2) - (2)].x), NULL);
		;}
    break;

  case 30:

/* Line 1455 of yacc.c  */
#line 255 "grammar.y"
    {
		    do_syslog_args((yyvsp[(3) - (3)].x));
		    (yyval.x) = actExpr(ACT_SYSLOG, (yyvsp[(3) - (3)].x), (yyvsp[(2) - (3)].x));
		;}
    break;

  case 31:

/* Line 1455 of yacc.c  */
#line 260 "grammar.y"
    {   (yyval.x) = actExpr(ACT_PRINT, (yyvsp[(2) - (2)].x), NULL); ;}
    break;

  case 32:

/* Line 1455 of yacc.c  */
#line 262 "grammar.y"
    {   (yyval.x) = actExpr(ACT_PRINT, (yyvsp[(3) - (3)].x), (yyvsp[(2) - (3)].x)); ;}
    break;

  case 33:

/* Line 1455 of yacc.c  */
#line 264 "grammar.y"
    {
		    stomping = 1;
		    (yyval.x) = actExpr(ACT_STOMP, (yyvsp[(2) - (2)].x), NULL);
		;}
    break;

  case 34:

/* Line 1455 of yacc.c  */
#line 269 "grammar.y"
    {
		    stomping = 1;
		    (yyval.x) = actExpr(ACT_STOMP, (yyvsp[(3) - (3)].x), (yyvsp[(2) - (3)].x));
		;}
    break;

  case 35:

/* Line 1455 of yacc.c  */
#line 276 "grammar.y"
    {   gramerr(act_str, precede, opStrings(ACT_SEQ));
		    (yyval.x) = NULL; ;}
    break;

  case 36:

/* Line 1455 of yacc.c  */
#line 280 "grammar.y"
    {   gramerr(act_str, follow, opStrings(ACT_SEQ));
		    (yyval.x) = NULL; ;}
    break;

  case 37:

/* Line 1455 of yacc.c  */
#line 283 "grammar.y"
    {   gramerr(act_str, precede, opStrings(ACT_ALT));
		    (yyval.x) = NULL; ;}
    break;

  case 38:

/* Line 1455 of yacc.c  */
#line 286 "grammar.y"
    {   gramerr(act_str, follow, opStrings(ACT_ALT));
		    (yyval.x) = NULL; ;}
    break;

  case 39:

/* Line 1455 of yacc.c  */
#line 290 "grammar.y"
    {   gramerr(tstr_str, follow, opStrings(ACT_SHELL));
		    (yyval.x) = NULL; ;}
    break;

  case 40:

/* Line 1455 of yacc.c  */
#line 293 "grammar.y"
    {   gramerr(tstr_str, follow, opStrings(ACT_ALARM));
		    (yyval.x) = NULL; ;}
    break;

  case 41:

/* Line 1455 of yacc.c  */
#line 296 "grammar.y"
    {   gramerr(tstr_str, follow, opStrings(ACT_SYSLOG));
		    (yyval.x) = NULL; ;}
    break;

  case 42:

/* Line 1455 of yacc.c  */
#line 299 "grammar.y"
    {   gramerr(tstr_str, follow, opStrings(ACT_PRINT));
		    (yyval.x) = NULL; ;}
    break;

  case 43:

/* Line 1455 of yacc.c  */
#line 302 "grammar.y"
    {   gramerr(tstr_str, follow, opStrings(ACT_STOMP));
		    (yyval.x) = NULL; ;}
    break;

  case 44:

/* Line 1455 of yacc.c  */
#line 307 "grammar.y"
    {   (yyval.x) = actArgExpr((yyvsp[(1) - (1)].x), NULL); ;}
    break;

  case 45:

/* Line 1455 of yacc.c  */
#line 311 "grammar.y"
    {   (yyval.x) = actArgList(NULL, (yyvsp[(1) - (1)].s)); free((yyvsp[(1) - (1)].s)); ;}
    break;

  case 46:

/* Line 1455 of yacc.c  */
#line 313 "grammar.y"
    {   (yyval.x) = actArgList((yyvsp[(2) - (2)].x), (yyvsp[(1) - (2)].s)); free((yyvsp[(1) - (2)].s)); ;}
    break;

  case 47:

/* Line 1455 of yacc.c  */
#line 317 "grammar.y"
    {   (yyval.x) = (yyvsp[(2) - (3)].x); ;}
    break;

  case 48:

/* Line 1455 of yacc.c  */
#line 319 "grammar.y"
    {   (yyval.x) = (yyvsp[(1) - (1)].x); ;}
    break;

  case 49:

/* Line 1455 of yacc.c  */
#line 321 "grammar.y"
    {   (yyval.x) = (yyvsp[(1) - (1)].x); ;}
    break;

  case 50:

/* Line 1455 of yacc.c  */
#line 323 "grammar.y"
    {   (yyval.x) = boolConst(B_TRUE); ;}
    break;

  case 51:

/* Line 1455 of yacc.c  */
#line 325 "grammar.y"
    {   (yyval.x) = boolConst(B_FALSE); ;}
    break;

  case 52:

/* Line 1455 of yacc.c  */
#line 327 "grammar.y"
    {   (yyval.x) = unaryExpr(CND_NOT, (yyvsp[(2) - (2)].x)); ;}
    break;

  case 53:

/* Line 1455 of yacc.c  */
#line 329 "grammar.y"
    {   (yyval.x) = boolMergeExpr(CND_RISE, (yyvsp[(2) - (2)].x)); ;}
    break;

  case 54:

/* Line 1455 of yacc.c  */
#line 331 "grammar.y"
    {   (yyval.x) = boolMergeExpr(CND_FALL, (yyvsp[(2) - (2)].x)); ;}
    break;

  case 55:

/* Line 1455 of yacc.c  */
#line 333 "grammar.y"
    {   (yyval.x) = binaryExpr(CND_AND, (yyvsp[(1) - (3)].x), (yyvsp[(3) - (3)].x)); ;}
    break;

  case 56:

/* Line 1455 of yacc.c  */
#line 335 "grammar.y"
    {   (yyval.x) = binaryExpr(CND_OR, (yyvsp[(1) - (3)].x), (yyvsp[(3) - (3)].x)); ;}
    break;

  case 57:

/* Line 1455 of yacc.c  */
#line 337 "grammar.y"
    {   /*
		     * note args are reversed so bexp is to the "left"
		     * of the operand node in the expr tree
		     */
		    (yyval.x) = binaryExpr(CND_MATCH, (yyvsp[(3) - (3)].x), (yyvsp[(2) - (3)].x)); ;}
    break;

  case 58:

/* Line 1455 of yacc.c  */
#line 343 "grammar.y"
    {   (yyval.x) = binaryExpr(CND_NOMATCH, (yyvsp[(3) - (3)].x), (yyvsp[(2) - (3)].x)); ;}
    break;

  case 59:

/* Line 1455 of yacc.c  */
#line 347 "grammar.y"
    {   gramerr(bexp_str, follow, opStrings(CND_NOT));
		    (yyval.x) = NULL; ;}
    break;

  case 60:

/* Line 1455 of yacc.c  */
#line 350 "grammar.y"
    {   gramerr(bexp_str, follow, opStrings(CND_RISE));
		    (yyval.x) = NULL; ;}
    break;

  case 61:

/* Line 1455 of yacc.c  */
#line 353 "grammar.y"
    {   gramerr(bexp_str, follow, opStrings(CND_FALL));
		    (yyval.x) = NULL; ;}
    break;

  case 62:

/* Line 1455 of yacc.c  */
#line 356 "grammar.y"
    {   gramerr("regular expression", follow, opStrings(CND_MATCH));
		    (yyval.x) = NULL; ;}
    break;

  case 63:

/* Line 1455 of yacc.c  */
#line 359 "grammar.y"
    {   gramerr(bexp_str, follow, "regular expression");
		    (yyval.x) = NULL; ;}
    break;

  case 64:

/* Line 1455 of yacc.c  */
#line 362 "grammar.y"
    {   gramerr("regular expression", follow, opStrings(CND_NOMATCH));
		    (yyval.x) = NULL; ;}
    break;

  case 65:

/* Line 1455 of yacc.c  */
#line 365 "grammar.y"
    {   gramerr(bexp_str, follow, "regular expression");
		    (yyval.x) = NULL; ;}
    break;

  case 66:

/* Line 1455 of yacc.c  */
#line 369 "grammar.y"
    {   gramerr(bexp_str, precede, opStrings(CND_AND));
		    (yyval.x) = NULL; ;}
    break;

  case 67:

/* Line 1455 of yacc.c  */
#line 372 "grammar.y"
    {   gramerr(bexp_str, follow, opStrings(CND_AND));
		    (yyval.x) = NULL; ;}
    break;

  case 68:

/* Line 1455 of yacc.c  */
#line 375 "grammar.y"
    {   gramerr(bexp_str, precede, opStrings(CND_OR));
		    (yyval.x) = NULL; ;}
    break;

  case 69:

/* Line 1455 of yacc.c  */
#line 378 "grammar.y"
    {   gramerr(bexp_str, follow, opStrings(CND_OR));
		    (yyval.x) = NULL; ;}
    break;

  case 70:

/* Line 1455 of yacc.c  */
#line 384 "grammar.y"
    {   (yyval.x) = domainExpr(CND_ALL_HOST, (yyvsp[(2) - (3)].i), (yyvsp[(3) - (3)].x)); ;}
    break;

  case 71:

/* Line 1455 of yacc.c  */
#line 386 "grammar.y"
    {   (yyval.x) = domainExpr(CND_SOME_HOST, (yyvsp[(2) - (3)].i), (yyvsp[(3) - (3)].x)); ;}
    break;

  case 72:

/* Line 1455 of yacc.c  */
#line 388 "grammar.y"
    {   (yyval.x) = percentExpr((yyvsp[(1) - (4)].d), (yyvsp[(3) - (4)].i), (yyvsp[(4) - (4)].x)); ;}
    break;

  case 73:

/* Line 1455 of yacc.c  */
#line 392 "grammar.y"
    {   gramerr(bexp_str, follow, quant_str);
		    (yyval.x) = NULL; ;}
    break;

  case 74:

/* Line 1455 of yacc.c  */
#line 395 "grammar.y"
    {   gramerr(bexp_str, follow, quant_str);
		    (yyval.x) = NULL; ;}
    break;

  case 75:

/* Line 1455 of yacc.c  */
#line 398 "grammar.y"
    {   gramerr(bexp_str, follow, quant_str);
		    (yyval.x) = NULL; ;}
    break;

  case 76:

/* Line 1455 of yacc.c  */
#line 401 "grammar.y"
    {   gramerr(num_str, precede, pcnt_str);
		    (yyval.x) = NULL; ;}
    break;

  case 77:

/* Line 1455 of yacc.c  */
#line 406 "grammar.y"
    {
		    if ((yyvsp[(1) - (3)].x) != NULL && (yyvsp[(3) - (3)].x) != NULL)
			(yyval.x) = relExpr(CND_EQ, (yyvsp[(1) - (3)].x), (yyvsp[(3) - (3)].x));
		    else {
			if ((yyvsp[(1) - (3)].x) != NULL)
			    freeExpr((yyvsp[(1) - (3)].x));
			if ((yyvsp[(3) - (3)].x) != NULL)
			    freeExpr((yyvsp[(3) - (3)].x));
			(yyval.x) = NULL;
		    }
		;}
    break;

  case 78:

/* Line 1455 of yacc.c  */
#line 418 "grammar.y"
    {
		    if ((yyvsp[(1) - (3)].x) != NULL && (yyvsp[(3) - (3)].x) != NULL)
			(yyval.x) = relExpr(CND_NEQ, (yyvsp[(1) - (3)].x), (yyvsp[(3) - (3)].x));
		    else {
			if ((yyvsp[(1) - (3)].x) != NULL)
			    freeExpr((yyvsp[(1) - (3)].x));
			if ((yyvsp[(3) - (3)].x) != NULL)
			    freeExpr((yyvsp[(3) - (3)].x));
			(yyval.x) = NULL;
		    }
		;}
    break;

  case 79:

/* Line 1455 of yacc.c  */
#line 430 "grammar.y"
    {
		    if ((yyvsp[(1) - (3)].x) != NULL && (yyvsp[(3) - (3)].x) != NULL)
			(yyval.x) = relExpr(CND_LT, (yyvsp[(1) - (3)].x), (yyvsp[(3) - (3)].x));
		    else {
			if ((yyvsp[(1) - (3)].x) != NULL)
			    freeExpr((yyvsp[(1) - (3)].x));
			if ((yyvsp[(3) - (3)].x) != NULL)
			    freeExpr((yyvsp[(3) - (3)].x));
			(yyval.x) = NULL;
		    }
		;}
    break;

  case 80:

/* Line 1455 of yacc.c  */
#line 442 "grammar.y"
    {
		    if ((yyvsp[(1) - (3)].x) != NULL && (yyvsp[(3) - (3)].x) != NULL)
			(yyval.x) = relExpr(CND_GT, (yyvsp[(1) - (3)].x), (yyvsp[(3) - (3)].x));
		    else {
			if ((yyvsp[(1) - (3)].x) != NULL)
			    freeExpr((yyvsp[(1) - (3)].x));
			if ((yyvsp[(3) - (3)].x) != NULL)
			    freeExpr((yyvsp[(3) - (3)].x));
			(yyval.x) = NULL;
		    }
		;}
    break;

  case 81:

/* Line 1455 of yacc.c  */
#line 454 "grammar.y"
    {
		    if ((yyvsp[(1) - (3)].x) != NULL && (yyvsp[(3) - (3)].x) != NULL)
			(yyval.x) = relExpr(CND_LTE, (yyvsp[(1) - (3)].x), (yyvsp[(3) - (3)].x));
		    else {
			if ((yyvsp[(1) - (3)].x) != NULL)
			    freeExpr((yyvsp[(1) - (3)].x));
			if ((yyvsp[(3) - (3)].x) != NULL)
			    freeExpr((yyvsp[(3) - (3)].x));
			(yyval.x) = NULL;
		    }
		;}
    break;

  case 82:

/* Line 1455 of yacc.c  */
#line 466 "grammar.y"
    {
		    if ((yyvsp[(1) - (3)].x) != NULL && (yyvsp[(3) - (3)].x) != NULL)
			(yyval.x) = relExpr(CND_GTE, (yyvsp[(1) - (3)].x), (yyvsp[(3) - (3)].x));
		    else {
			if ((yyvsp[(1) - (3)].x) != NULL)
			    freeExpr((yyvsp[(1) - (3)].x));
			if ((yyvsp[(3) - (3)].x) != NULL)
			    freeExpr((yyvsp[(3) - (3)].x));
			(yyval.x) = NULL;
		    }
		;}
    break;

  case 83:

/* Line 1455 of yacc.c  */
#line 480 "grammar.y"
    {   gramerr(aexp_str, precede, opStrings(CND_EQ));
		    (yyval.x) = NULL; ;}
    break;

  case 84:

/* Line 1455 of yacc.c  */
#line 483 "grammar.y"
    {   gramerr(pexp_str, follow, opStrings(CND_EQ));
		    (yyval.x) = NULL; ;}
    break;

  case 85:

/* Line 1455 of yacc.c  */
#line 486 "grammar.y"
    {   gramerr(aexp_str, precede, opStrings(CND_NEQ));
		    (yyval.x) = NULL; ;}
    break;

  case 86:

/* Line 1455 of yacc.c  */
#line 489 "grammar.y"
    {   gramerr(pexp_str, follow, opStrings(CND_NEQ));
		    (yyval.x) = NULL; ;}
    break;

  case 87:

/* Line 1455 of yacc.c  */
#line 492 "grammar.y"
    {   gramerr(aexp_str, precede, opStrings(CND_LT));
		    (yyval.x) = NULL; ;}
    break;

  case 88:

/* Line 1455 of yacc.c  */
#line 495 "grammar.y"
    {   gramerr(aexp_str, follow, opStrings(CND_LT));
		    (yyval.x) = NULL; ;}
    break;

  case 89:

/* Line 1455 of yacc.c  */
#line 498 "grammar.y"
    {   gramerr(aexp_str, precede, opStrings(CND_GT));
		    (yyval.x) = NULL; ;}
    break;

  case 90:

/* Line 1455 of yacc.c  */
#line 501 "grammar.y"
    {   gramerr(aexp_str, follow, opStrings(CND_GT));
		    (yyval.x) = NULL; ;}
    break;

  case 91:

/* Line 1455 of yacc.c  */
#line 504 "grammar.y"
    {   gramerr(aexp_str, precede, opStrings(CND_LTE));
		    (yyval.x) = NULL; ;}
    break;

  case 92:

/* Line 1455 of yacc.c  */
#line 507 "grammar.y"
    {   gramerr(aexp_str, follow, opStrings(CND_LTE));
		    (yyval.x) = NULL; ;}
    break;

  case 93:

/* Line 1455 of yacc.c  */
#line 510 "grammar.y"
    {   gramerr(aexp_str, precede, opStrings(CND_GTE));
		    (yyval.x) = NULL; ;}
    break;

  case 94:

/* Line 1455 of yacc.c  */
#line 513 "grammar.y"
    {   gramerr(aexp_str, follow, opStrings(CND_GTE));
		    (yyval.x) = NULL; ;}
    break;

  case 95:

/* Line 1455 of yacc.c  */
#line 518 "grammar.y"
    {   (yyval.x) = (yyvsp[(2) - (3)].x); ;}
    break;

  case 96:

/* Line 1455 of yacc.c  */
#line 520 "grammar.y"
    {   (yyval.x) = (yyvsp[(1) - (1)].x); ;}
    break;

  case 97:

/* Line 1455 of yacc.c  */
#line 522 "grammar.y"
    {   (yyval.x) = (yyvsp[(1) - (1)].x); ;}
    break;

  case 98:

/* Line 1455 of yacc.c  */
#line 524 "grammar.y"
    {   (yyval.x) = (yyvsp[(1) - (1)].x); ;}
    break;

  case 99:

/* Line 1455 of yacc.c  */
#line 526 "grammar.y"
    {   (yyval.x) = (yyvsp[(1) - (1)].x); ;}
    break;

  case 100:

/* Line 1455 of yacc.c  */
#line 528 "grammar.y"
    {   if ((yyvsp[(2) - (2)].x) != NULL)
			(yyval.x) = numMergeExpr(CND_RATE, (yyvsp[(2) - (2)].x));
		    else
			(yyval.x) = NULL;
		;}
    break;

  case 101:

/* Line 1455 of yacc.c  */
#line 534 "grammar.y"
    {   if ((yyvsp[(2) - (2)].x) != NULL) {
			(yyvsp[(2) - (2)].x)->sem = PM_SEM_INSTANT;
			(yyval.x) = unaryExpr(CND_INSTANT, (yyvsp[(2) - (2)].x));
		    }
		    else
			(yyval.x) = NULL;
		;}
    break;

  case 102:

/* Line 1455 of yacc.c  */
#line 542 "grammar.y"
    {   if ((yyvsp[(2) - (2)].x) != NULL)
			(yyval.x) = unaryExpr(CND_NEG, (yyvsp[(2) - (2)].x));
		    else
			(yyval.x) = NULL;
		;}
    break;

  case 103:

/* Line 1455 of yacc.c  */
#line 548 "grammar.y"
    {   if ((yyvsp[(1) - (3)].x) != NULL && (yyvsp[(3) - (3)].x) != NULL)
			(yyval.x) = binaryExpr(CND_ADD, (yyvsp[(1) - (3)].x), (yyvsp[(3) - (3)].x));
		    else {
			if ((yyvsp[(1) - (3)].x) != NULL)
			    freeExpr((yyvsp[(1) - (3)].x));
			if ((yyvsp[(3) - (3)].x) != NULL)
			    freeExpr((yyvsp[(3) - (3)].x));
			(yyval.x) = NULL;
		    }
		;}
    break;

  case 104:

/* Line 1455 of yacc.c  */
#line 559 "grammar.y"
    {   if ((yyvsp[(1) - (3)].x) != NULL && (yyvsp[(3) - (3)].x) != NULL)
			(yyval.x) = binaryExpr(CND_SUB, (yyvsp[(1) - (3)].x), (yyvsp[(3) - (3)].x));
		    else {
			if ((yyvsp[(1) - (3)].x) != NULL)
			    freeExpr((yyvsp[(1) - (3)].x));
			if ((yyvsp[(3) - (3)].x) != NULL)
			    freeExpr((yyvsp[(3) - (3)].x));
			(yyval.x) = NULL;
		    }
		;}
    break;

  case 105:

/* Line 1455 of yacc.c  */
#line 570 "grammar.y"
    {   if ((yyvsp[(1) - (3)].x) != NULL && (yyvsp[(3) - (3)].x) != NULL)
			(yyval.x) = binaryExpr(CND_MUL, (yyvsp[(1) - (3)].x), (yyvsp[(3) - (3)].x));
		    else {
			if ((yyvsp[(1) - (3)].x) != NULL)
			    freeExpr((yyvsp[(1) - (3)].x));
			if ((yyvsp[(3) - (3)].x) != NULL)
			    freeExpr((yyvsp[(3) - (3)].x));
			(yyval.x) = NULL;
		    }
		;}
    break;

  case 106:

/* Line 1455 of yacc.c  */
#line 581 "grammar.y"
    {   if ((yyvsp[(1) - (3)].x) != NULL && (yyvsp[(3) - (3)].x) != NULL)
			(yyval.x) = binaryExpr(CND_DIV, (yyvsp[(1) - (3)].x), (yyvsp[(3) - (3)].x));
		    else {
			if ((yyvsp[(1) - (3)].x) != NULL)
			    freeExpr((yyvsp[(1) - (3)].x));
			if ((yyvsp[(3) - (3)].x) != NULL)
			    freeExpr((yyvsp[(3) - (3)].x));
			(yyval.x) = NULL;
		    }
		;}
    break;

  case 107:

/* Line 1455 of yacc.c  */
#line 594 "grammar.y"
    {   gramerr(aexp_str, follow, opStrings(CND_RATE));
		    (yyval.x) = NULL; ;}
    break;

  case 108:

/* Line 1455 of yacc.c  */
#line 597 "grammar.y"
    {   gramerr(aexp_str, follow, opStrings(CND_INSTANT));
		    (yyval.x) = NULL; ;}
    break;

  case 109:

/* Line 1455 of yacc.c  */
#line 600 "grammar.y"
    {   gramerr(aexp_str, follow, opStrings(CND_NEG));
		    (yyval.x) = NULL; ;}
    break;

  case 110:

/* Line 1455 of yacc.c  */
#line 604 "grammar.y"
    {   gramerr(aexp_str, precede, opStrings(CND_ADD));
		    (yyval.x) = NULL; ;}
    break;

  case 111:

/* Line 1455 of yacc.c  */
#line 607 "grammar.y"
    {   gramerr(aexp_str, follow, opStrings(CND_ADD));
		    (yyval.x) = NULL; ;}
    break;

  case 112:

/* Line 1455 of yacc.c  */
#line 610 "grammar.y"
    {   gramerr(aexp_str, precede, opStrings(CND_SUB));
		    (yyval.x) = NULL; ;}
    break;

  case 113:

/* Line 1455 of yacc.c  */
#line 613 "grammar.y"
    {   gramerr(aexp_str, follow, opStrings(CND_SUB));
		    (yyval.x) = NULL; ;}
    break;

  case 114:

/* Line 1455 of yacc.c  */
#line 616 "grammar.y"
    {   gramerr(aexp_str, precede, opStrings(CND_MUL));
		    (yyval.x) = NULL; ;}
    break;

  case 115:

/* Line 1455 of yacc.c  */
#line 619 "grammar.y"
    {   gramerr(aexp_str, follow, opStrings(CND_MUL));
		    (yyval.x) = NULL; ;}
    break;

  case 116:

/* Line 1455 of yacc.c  */
#line 622 "grammar.y"
    {   gramerr(aexp_str, precede, opStrings(CND_DIV));
		    (yyval.x) = NULL; ;}
    break;

  case 117:

/* Line 1455 of yacc.c  */
#line 625 "grammar.y"
    {   gramerr(aexp_str, follow, opStrings(CND_DIV));
		    (yyval.x) = NULL; ;}
    break;

  case 118:

/* Line 1455 of yacc.c  */
#line 631 "grammar.y"
    {   (yyval.x) = (yyvsp[(1) - (1)].x); ;}
    break;

  case 119:

/* Line 1455 of yacc.c  */
#line 633 "grammar.y"
    {   (yyval.x) = (yyvsp[(1) - (1)].x); ;}
    break;

  case 120:

/* Line 1455 of yacc.c  */
#line 637 "grammar.y"
    {   (yyval.x) = domainExpr(CND_SUM_HOST, (yyvsp[(2) - (3)].i), (yyvsp[(3) - (3)].x)); ;}
    break;

  case 121:

/* Line 1455 of yacc.c  */
#line 639 "grammar.y"
    {   (yyval.x) = domainExpr(CND_AVG_HOST, (yyvsp[(2) - (3)].i), (yyvsp[(3) - (3)].x)); ;}
    break;

  case 122:

/* Line 1455 of yacc.c  */
#line 641 "grammar.y"
    {   (yyval.x) = domainExpr(CND_MAX_HOST, (yyvsp[(2) - (3)].i), (yyvsp[(3) - (3)].x)); ;}
    break;

  case 123:

/* Line 1455 of yacc.c  */
#line 643 "grammar.y"
    {   (yyval.x) = domainExpr(CND_MIN_HOST, (yyvsp[(2) - (3)].i), (yyvsp[(3) - (3)].x)); ;}
    break;

  case 124:

/* Line 1455 of yacc.c  */
#line 645 "grammar.y"
    {   (yyval.x) = domainExpr(CND_COUNT_HOST, (yyvsp[(2) - (3)].i), (yyvsp[(3) - (3)].x)); ;}
    break;

  case 125:

/* Line 1455 of yacc.c  */
#line 649 "grammar.y"
    {   gramerr(aexp_str, follow, aggr_str);
		    (yyval.x) = NULL; ;}
    break;

  case 126:

/* Line 1455 of yacc.c  */
#line 652 "grammar.y"
    {   gramerr(aexp_str, follow, aggr_str);
		    (yyval.x) = NULL; ;}
    break;

  case 127:

/* Line 1455 of yacc.c  */
#line 655 "grammar.y"
    {   gramerr(aexp_str, follow, aggr_str);
		    (yyval.x) = NULL; ;}
    break;

  case 128:

/* Line 1455 of yacc.c  */
#line 658 "grammar.y"
    {   gramerr(aexp_str, follow, aggr_str);
		    (yyval.x) = NULL; ;}
    break;

  case 129:

/* Line 1455 of yacc.c  */
#line 661 "grammar.y"
    {   gramerr(bexp_str, follow, aggr_str);
		    (yyval.x) = NULL; ;}
    break;

  case 130:

/* Line 1455 of yacc.c  */
#line 666 "grammar.y"
    {   (yyval.i) = HOST_DOM; ;}
    break;

  case 131:

/* Line 1455 of yacc.c  */
#line 668 "grammar.y"
    {   (yyval.i) = INST_DOM; ;}
    break;

  case 132:

/* Line 1455 of yacc.c  */
#line 670 "grammar.y"
    {   (yyval.i) = TIME_DOM; ;}
    break;

  case 133:

/* Line 1455 of yacc.c  */
#line 674 "grammar.y"
    {   (yyval.x) = fetchExpr((yyvsp[(1) - (4)].s), (yyvsp[(2) - (4)].sa), (yyvsp[(3) - (4)].sa), (yyvsp[(4) - (4)].t)); free((yyvsp[(1) - (4)].s)); ;}
    break;

  case 134:

/* Line 1455 of yacc.c  */
#line 678 "grammar.y"
    {   (yyval.s) = (yyvsp[(1) - (1)].s); ;}
    break;

  case 135:

/* Line 1455 of yacc.c  */
#line 682 "grammar.y"
    {   (yyval.sa).n = 0;
		    (yyval.sa).ss = NULL; ;}
    break;

  case 136:

/* Line 1455 of yacc.c  */
#line 685 "grammar.y"
    {   (yyval.sa).n = (yyvsp[(1) - (3)].sa).n + 1;
		    (yyval.sa).ss = (char **) ralloc((yyvsp[(1) - (3)].sa).ss, (yyval.sa).n * sizeof(char *));
		    (yyval.sa).ss[(yyvsp[(1) - (3)].sa).n] = (yyvsp[(3) - (3)].s); ;}
    break;

  case 137:

/* Line 1455 of yacc.c  */
#line 691 "grammar.y"
    {   gramerr(host_str, follow, ":");
                    (yyval.sa).n = 0;
		    (yyval.sa).ss = NULL; ;}
    break;

  case 138:

/* Line 1455 of yacc.c  */
#line 697 "grammar.y"
    {   (yyval.sa).n = 0;
		    (yyval.sa).ss = NULL; ;}
    break;

  case 139:

/* Line 1455 of yacc.c  */
#line 700 "grammar.y"
    {   (yyval.sa).n = (yyvsp[(1) - (3)].sa).n + 1;
		    (yyval.sa).ss = (char **) ralloc((yyvsp[(1) - (3)].sa).ss, (yyval.sa).n * sizeof(char *));
		    (yyval.sa).ss[(yyvsp[(1) - (3)].sa).n] = (yyvsp[(3) - (3)].s); ;}
    break;

  case 140:

/* Line 1455 of yacc.c  */
#line 706 "grammar.y"
    {   gramerr(inst_str, follow, "#");
                    (yyval.sa).n = 0;
		    (yyval.sa).ss = NULL; ;}
    break;

  case 141:

/* Line 1455 of yacc.c  */
#line 712 "grammar.y"
    {   (yyval.t).t1 = 0;
		    (yyval.t).t2 = 0; ;}
    break;

  case 142:

/* Line 1455 of yacc.c  */
#line 715 "grammar.y"
    {   (yyval.t).t1 = (yyvsp[(2) - (2)].d);
		    (yyval.t).t2 = (yyvsp[(2) - (2)].d); ;}
    break;

  case 143:

/* Line 1455 of yacc.c  */
#line 718 "grammar.y"
    {   if ((yyvsp[(2) - (4)].d) <= (yyvsp[(4) - (4)].d)) {
			(yyval.t).t1 = (yyvsp[(2) - (4)].d);
			(yyval.t).t2 = (yyvsp[(4) - (4)].d);
		    }
		    else {
			(yyval.t).t1 = (yyvsp[(4) - (4)].d);
			(yyval.t).t2 = (yyvsp[(2) - (4)].d);
		    } ;}
    break;

  case 144:

/* Line 1455 of yacc.c  */
#line 729 "grammar.y"
    {   gramerr(sample_str, follow, "@");
                    (yyval.t).t1 = 0;
                    (yyval.t).t2 = 0; ;}
    break;

  case 145:

/* Line 1455 of yacc.c  */
#line 735 "grammar.y"
    {   (yyval.x) = numConst((yyvsp[(1) - (2)].d), (yyvsp[(2) - (2)].u)); ;}
    break;

  case 146:

/* Line 1455 of yacc.c  */
#line 739 "grammar.y"
    {   (yyval.u) = noUnits; ;}
    break;

  case 147:

/* Line 1455 of yacc.c  */
#line 741 "grammar.y"
    {   (yyval.u) = (yyvsp[(1) - (2)].u);
		    if ((yyvsp[(2) - (2)].u).dimSpace) {
			(yyval.u).dimSpace = (yyvsp[(2) - (2)].u).dimSpace;
			(yyval.u).scaleSpace = (yyvsp[(2) - (2)].u).scaleSpace;
		    }
		    else if ((yyvsp[(2) - (2)].u).dimTime) {
			(yyval.u).dimTime = (yyvsp[(2) - (2)].u).dimTime;
			(yyval.u).scaleTime = (yyvsp[(2) - (2)].u).scaleTime;
		    }
		    else {
			(yyval.u).dimCount = (yyvsp[(2) - (2)].u).dimCount;
			(yyval.u).scaleCount = (yyvsp[(2) - (2)].u).scaleCount;
		    } ;}
    break;

  case 148:

/* Line 1455 of yacc.c  */
#line 755 "grammar.y"
    {   (yyval.u) = (yyvsp[(1) - (3)].u);
		    if ((yyvsp[(3) - (3)].u).dimSpace) {
			(yyval.u).dimSpace = -(yyvsp[(3) - (3)].u).dimSpace;
			(yyval.u).scaleSpace = (yyvsp[(3) - (3)].u).scaleSpace;
		    }
		    else if ((yyvsp[(3) - (3)].u).dimTime) {
			(yyval.u).dimTime = -(yyvsp[(3) - (3)].u).dimTime;
			(yyval.u).scaleTime = (yyvsp[(3) - (3)].u).scaleTime;
		    }
		    else {
			(yyval.u).dimCount = -(yyvsp[(3) - (3)].u).dimCount;
			(yyval.u).scaleCount = (yyvsp[(3) - (3)].u).scaleCount;
		    } ;}
    break;

  case 149:

/* Line 1455 of yacc.c  */
#line 771 "grammar.y"
    {   (yyval.u) = (yyvsp[(1) - (1)].u); ;}
    break;

  case 150:

/* Line 1455 of yacc.c  */
#line 773 "grammar.y"
    {   (yyval.u) = (yyvsp[(1) - (3)].u);
		    (yyval.u).dimSpace = (yyvsp[(3) - (3)].d); ;}
    break;

  case 151:

/* Line 1455 of yacc.c  */
#line 776 "grammar.y"
    {   (yyval.u) = (yyvsp[(1) - (1)].u); ;}
    break;

  case 152:

/* Line 1455 of yacc.c  */
#line 778 "grammar.y"
    {   (yyval.u) = (yyvsp[(1) - (3)].u);
		    (yyval.u).dimTime = (yyvsp[(3) - (3)].d); ;}
    break;

  case 153:

/* Line 1455 of yacc.c  */
#line 781 "grammar.y"
    {   (yyval.u) = (yyvsp[(1) - (1)].u); ;}
    break;

  case 154:

/* Line 1455 of yacc.c  */
#line 783 "grammar.y"
    {   (yyval.u) = (yyvsp[(1) - (3)].u);
		    (yyval.u).dimCount = (yyvsp[(3) - (3)].d); ;}
    break;

  case 155:

/* Line 1455 of yacc.c  */
#line 788 "grammar.y"
    {   (yyval.x) = strConst((yyvsp[(1) - (1)].s)); free((yyvsp[(1) - (1)].s)); ;}
    break;



/* Line 1455 of yacc.c  */
#line 3224 "grammar.tab.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 1675 of yacc.c  */
#line 791 "grammar.y"



